import DeleteIcon from "/src/assets/trash-alt-svgrepo-com.svg";
import WrongIcon from "/src/assets/wrong-svgrepo-com.svg";
import TickIcon from "/src/assets/tick-circle-svgrepo-com.svg";
import { todo } from '../../types.dt'
import { useContext } from "react";
import { Provider } from "../../Context Api/Todos";
interface item extends todo {
    index: Number,
    handleDelete?: () => void
}
const Item = ({ name, index, completed, handleDelete }: item) => {
    const handleClick = (e: React.ChangeEvent<HTMLImageElement>) => {
        // console.log(index)
        handleDelete({ index })
    }
    return (
        <div className="item">
            <div className='item-content'>
                <input type='checkbox' id={`item-${index}`} />
                <label htmlFor={`item-${index}`}>{name}</label>
            </div>
            <div className='actions'>
                {
                    !completed ? (
                        <>
                            <img src={DeleteIcon} alt="delete" onClick={handleClick} />
                            <img src={WrongIcon} alt="Not Done" />
                        </>
                    ) : (

                        <img src={TickIcon} alt="Done" />
                    )
                }
            </div>
        </div>
    )
}

export default Item