import React, { useReducer, useContext, createContext, Children } from 'react';
import { action, params, todo } from '../types.dt';
export const Provider = createContext(null)
const Todos = ({ children }: {
    children: React.ReactNode
}) => {
    const reducer = (state: todo[], action: action) => {
        switch (action.type) {
            case 'Create':
                console.log(action)
                return [...state, { name: action.name, completed: false }]
            case "Update":
                state[action.index].name = action.name
                return state
            case "Delete":
                return state.filter((data, i) => {
                    return action.index !== i
                })
            default:
                return state;
        }
    }

    const initialValues: todo[] = [{
        name: 'Eren Yeager',
        completed: false,
    }, {
        name: "Hange Zoe",
        completed: false
    }]
    const [state, dispatch] = useReducer(reducer, initialValues)

    const handleCreate = (data: params): void => {
        // console.log({ ...data }, "handleCreate")
        dispatch({ type: "Create", ...data })
    }
    const handleUpdate = (data: params) => {
        dispatch({ type: "Update", ...data })
    }
    const handleDelete = (data: params) => {
        dispatch({ type: "Delete", ...data })
    }
    return (
        <Provider.Provider value={{ state, handleCreate, handleDelete, handleUpdate }}>
            {children}
        </Provider.Provider>
    )
}

export default Todos